const COMPOSEDBG = false;
class PcTemplates //static class, helper only
{
  static initialize()
  {
    this.resources = [];
  }

  static getTemplate(paper, poses, layout)
  {
    let res =
      {
        size:
        {
          width:0,
          height:0
        },
        poses:[]
      };

    let normalPoses = [
      {x:56, y:56, width:516, height:516},
      {x:628, y:56, width:516, height:516},
      {x:56, y:628, width:516, height:516},
      {x:628, y:628, width:516, height:516}
    ];

    let normalPoses5x15 = [
      {x:42, y:42, width:516, height:344},
      {x:42, y:417, width:516, height:344},
      {x:42, y:792, width:516, height:344},
      {x:42, y:1167, width:516, height:344}
    ];

    let normalPoses15x15 = [
      {x:84, y:84, width:774, height:774},
      {x:942, y:84, width:774, height:774},
      {x:84, y:942, width:774, height:774},
      {x:942, y:942, width:774, height:774}
    ];

    let fullPoses10x15 = [
      {x:0, y:0, width:600, height:900},
      {x:600, y:0, width:600, height:900},
      {x:0, y:900, width:600, height:900},
      {x:600, y:900, width:600, height:900}
    ];

    let fullPoses15x10 = [
      {x:0, y:0, width:900, height:600},
      {x:900, y:0, width:900, height:600},
      {x:0, y:600, width:900, height:600},
      {x:900, y:600, width:900, height:600}
    ];

    let fullPoses5x15 = [
      {x:0, y:0, width:600, height:450},
      {x:0, y:450, width:600, height:450},
      {x:0, y:900, width:600, height:450},
      {x:0, y:1350, width:600, height:450}
    ];

    let fullPoses15x15 = [
      {x:0, y:0, width:900, height:900},
      {x:0, y:900, width:900, height:900},
      {x:900, y:0, width:900, height:900},
      {x:900, y:900, width:900, height:900}
    ];

    switch (paper)
    {
      case "10x15" :
        res.size.width=1200; res.size.height=1800;
        switch (poses)
        {
          case "1" :
            switch (layout)
            {
              case "normal" : res.poses = [{x:56, y:56, width:1088, height:1088}]; break;
              case "captur" : res.poses = [{x:0, y:0, width:1200, height:1200}]; break;
              case "20minutes" : res.poses = [{x:324, y:101, width:833, height:1461}]; break;
              case "vuitton" : res.poses = [{x:63, y:63, width:1074, height:1346}]; break;
              case "feteinfrance" : res.poses = [{x:142, y:142, width:916, height:1095}]; break;
              default : res.poses = [{x:0, y:0, width:1200, height:1800}];
            }
            break;
          case "1-4" : layout=="normal" ? res.poses = normalPoses.slice(0,1) : res.poses = fullPoses10x15.slice(0,1); break;
          case "2-4" : layout=="normal" ? res.poses = normalPoses.slice(0,2) : res.poses = fullPoses10x15.slice(0,2); break;
          case "3-4" : layout=="normal" ? res.poses = normalPoses.slice(0,3) : res.poses = fullPoses10x15.slice(0,3); break;
          case "4-4" : layout=="normal" ? res.poses = normalPoses.slice(0,4) : res.poses = fullPoses10x15.slice(0,4); break;
        }
        break;
      case "15x10" :
          res.size.width=1800; res.size.height=1200;
          switch (poses)
          {
            case "1" : layout=="normal" ? res.poses = [{x:56, y:56, width:1088, height:1088}] : res.poses = [{x:0, y:0, width:1800, height:1200}]; break;
            case "1-4" : layout=="normal" ? res.poses = normalPoses.slice(0,1) : res.poses = fullPoses15x10.slice(0,1); break;
            case "2-4" : layout=="normal" ? res.poses = normalPoses.slice(0,2) : res.poses = fullPoses15x10.slice(0,2); break;
            case "3-4" : layout=="normal" ? res.poses = normalPoses.slice(0,3) : res.poses = fullPoses15x10.slice(0,3); break;
            case "4-4" : layout=="normal" ? res.poses = normalPoses.slice(0,4) : res.poses = fullPoses15x10.slice(0,4); break;
          }
          break;
      case "5x15" :
        res.size.width=600; res.size.height=1800;
        switch (poses)
        {
          case "1" : res.poses = [{x:0, y:0, width:600, height:1800}]; break;
          case "1-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,1) : res.poses = fullPoses5x15.slice(0,1); break;
          case "2-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,2) : res.poses = fullPoses5x15.slice(0,2); break;
          case "3-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,3) : res.poses = fullPoses5x15.slice(0,3); break;
          case "4-4" : layout=="normal" ? res.poses = normalPoses5x15.slice(0,4) : res.poses = fullPoses5x15.slice(0,4); break;
        }
        break;
      case "15x15" :
          res.size.width=1800; res.size.height=1800;
          switch (poses)
          {
            case "1" : res.poses = [{x:0, y:0, width:1800, height:1800}]; break;
            case "1-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,1) : res.poses = fullPoses15x15.slice(0,1); break;
            case "2-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,2) : res.poses = fullPoses15x15.slice(0,2); break;
            case "3-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,3) : res.poses = fullPoses15x15.slice(0,3); break;
            case "4-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,4) : res.poses = fullPoses15x15.slice(0,4); break;
          }
          break;
      case "amundi" :
          res.size.width=3791; res.size.height=3791;
          switch (poses)
          {
            case "1" : res.poses = [{x:0, y:0, width:3791, height:3791}]; break;
            case "1-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,1) : res.poses = fullPoses15x15.slice(0,1); break;
            case "2-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,2) : res.poses = fullPoses15x15.slice(0,2); break;
            case "3-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,3) : res.poses = fullPoses15x15.slice(0,3); break;
            case "4-4" : layout=="normal" ? res.poses = normalPoses15x15.slice(0,4) : res.poses = fullPoses15x15.slice(0,4); break;
          }
          break;
    }

    return res;
  }

  static createThumb(frames, w, h)
  {
    var canvas = document.createElement('canvas');
    var context = canvas.getContext('2d');
    context.globalAlpha = 1;
    canvas.width = w;
    canvas.height = h;

    let frame = PcTemplates.getZoomCropCanvas(frames[0], w, h);
    context.drawImage(frame, 0, 0, w, h);
    frame = null;

    return canvas;
  }

  static createRoundRect(ctx, x, y, width, height, radius, fill, stroke)
  {
    if (typeof stroke === 'undefined') { stroke = true;}
    if (typeof radius === 'undefined') { radius = 5;}
    if (typeof radius === 'number') {
      radius = {tl: radius, tr: radius, br: radius, bl: radius};
    } else {
      var defaultRadius = {tl: 0, tr: 0, br: 0, bl: 0};
      for (var side in defaultRadius) {
        radius[side] = radius[side] || defaultRadius[side];
      }
    }
    ctx.beginPath();
    ctx.moveTo(x + radius.tl, y);
    ctx.lineTo(x + width - radius.tr, y);
    ctx.quadraticCurveTo(x + width, y, x + width, y + radius.tr);
    ctx.lineTo(x + width, y + height - radius.br);
    ctx.quadraticCurveTo(x + width, y + height, x + width - radius.br, y + height);
    ctx.lineTo(x + radius.bl, y + height);
    ctx.quadraticCurveTo(x, y + height, x, y + height - radius.bl);
    ctx.lineTo(x, y + radius.tl);
    ctx.quadraticCurveTo(x, y, x + radius.tl, y);
    ctx.closePath();
    if (fill) {
      ctx.fill();
    }
    if (stroke) {
      ctx.stroke();
    }
  }

  static _init_canvas(canvas, alpha, width, height) 
  {
    canvas.width = width;
    canvas.height = height;

    var context = canvas.getContext('2d');

    context.globalAlpha = alpha;
    context.imageSmoothingEnabled=true;
    context.imageSmoothingEnabled="high"; 
    return context; 
  }

  static createComposedFrames(format, color, backgroundUrl, foregroundUrl, frames, filter_dict, useRemoveBg)
  {
    let paper = format.paper;
    let poses = format.poses;
    let layout = format.layout;
    let framing = format.framing;
    let autocrop = format.autocrop;

    var template = PcTemplates.getTemplate(paper, poses, layout);
    var imgBackground = PcTemplates.getResource(backgroundUrl);
    var imgForeground = PcTemplates.getResource(foregroundUrl);

    var full_composition_canvas = document.createElement('canvas');
    var full_composition_context = this._init_canvas(full_composition_canvas, 1, template.size.width, template.size.height);
    PcDbg.log(COMPOSEDBG, "full composition_canvas size", full_composition_canvas.width, full_composition_canvas.height);
    /*
    context.globalAlpha = 1;

    context.imageSmoothingEnabled=true;
    context.imageSmoothingQuality="high";

    compose_canvas.width = template.size.width;
    compose_canvas.height = template.size.height;
    */
    full_composition_context.fillStyle = color;

    //create the composition
    // 1. set background color
    full_composition_context.fillRect(0, 0, template.size.width, template.size.height);

    // 2. overlay background image on the full composition
    if (imgBackground) {
      full_composition_context.drawImage(imgBackground, 0, 0, template.size.width, template.size.height);
    }

    // 3. compose the poses
    let variation;
    for (let i=0; i<template.poses.length; i++)  {
      // let ratio = template.poses[i].width / template.poses[i].height;
      //3.a: resize the current frame
      let pose_x = template.poses[i].x;
      let pose_y = template.poses[i].y;
      let pose_width = template.poses[i].width;
      let pose_height = template.poses[i].height;

      let initial_filter_dict;
      let natural_filter_dict = { title:"none", filterName: "Naturel_Removebg", settings:"", id: "none_rbg: " };
      if (useRemoveBg) { // natural
        initial_filter_dict = natural_filter_dict;
        variation = 0;
      } else { //filtered with variation number (=pose number, for popart)
          initial_filter_dict = filter_dict;
          variation = i;
      }
      
      // the zoomed and filtered single photo
      let original_photo_canvas = frames[i].getFiltered(initial_filter_dict, variation, useRemoveBg);
      PcDbg.log(COMPOSEDBG, "original shot frame image size", original_photo_canvas.width, original_photo_canvas.height);
      let single_photo_canvas = PcTemplates.getZoomCropCanvas(
          original_photo_canvas,
          pose_width, pose_height,
          autocrop ? false : true);

          PcDbg.log(COMPOSEDBG, "single_photo_canvas size", single_photo_canvas.width, single_photo_canvas.height);
      if (SAVEDBG && useRemoveBg) {
          let filename = PcConfig.global.tmpDir + "1_single_photo_canvas_" + initial_filter_dict.name + "_" + + variation.toString() + ".png";
          PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
          PcConfig.saveCanvasToFile(single_photo_canvas, filename, "png");
      }
      var precomposed_photo_canvas = document.createElement('canvas');
      this._init_canvas(precomposed_photo_canvas, 1, pose_width, pose_height);
      var precomposed_photo_context = precomposed_photo_canvas.getContext('2d');

      //if we use RemoveBg, add the extracted background to precomposed photo
      if (useRemoveBg){ 
        precomposed_photo_context.drawImage(full_composition_canvas, /*source*/ pose_x, pose_y, pose_width, pose_height, /*dest*/ 0, 0, pose_width, pose_height);
      }
      if (SAVEDBG && useRemoveBg) {
        let filename = PcConfig.global.tmpDir + "2_precomposed_photocanvas_add_background_" + + variation.toString() + ".png";
        PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
        PcConfig.saveCanvasToFile(precomposed_photo_canvas, filename, "png");
      }

      PcDbg.log(COMPOSEDBG, "precomposed_photo_canvas size", precomposed_photo_canvas.width, precomposed_photo_canvas.height);
      if (framing=="rounded" && layout=="normal")  {
          // create the rounded rect shape
          this.createRoundRect(precomposed_photo_context, 0, 0, pose_width, pose_height, 35, true, false); // add the rect
          // clip context to this rounded rect shape
          precomposed_photo_context.clip();
      }

      // draw the frame in the single composed frame context:
      // we have a precomposition of the background color, the background image, the rect shape and the photo
      precomposed_photo_context.drawImage(single_photo_canvas, 0, 0, pose_width, pose_height);
      if (SAVEDBG && useRemoveBg) {
        let filename = PcConfig.global.tmpDir + "3_precomposed_photocanvas_add_single_photo_canvas_" + variation.toString() + ".png";
        PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
        PcConfig.saveCanvasToFile(precomposed_photo_canvas, filename, "png");
      }
      if (useRemoveBg) { // if we use RemoveBg, filter this precomposition
        // filter_dict = natural_filter_dict;
        let filtered_removebg_precomposed_photo_canvas = new PcCaptureSessionFrame(precomposed_photo_canvas, true).getFiltered(filter_dict, i, false);
        if (SAVEDBG && useRemoveBg) {
          let filename = PcConfig.global.tmpDir + "4_filtered_removebg_photo_canvas_" + filter_dict.name + "_" + + variation.toString() + ".png";
          PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
          PcConfig.saveCanvasToFile(filtered_removebg_precomposed_photo_canvas, filename, "png");
        }
        /*
        PcDbg.log(COMPOSEDBG, "filtered_removebg_photo_canvas size", filtered_removebg_photo_canvas.width, filtered_removebg_photo_canvas.height);
        let filtered_precomposed_photo_canvas = PcTemplates.getZoomCropCanvas(
          filtered_removebg_photo_canvas,
          pose_width, pose_height,
          autocrop ? false : true);
          PcDbg.log(COMPOSEDBG, "filtered_precomposed_photo_canvas size", filtered_precomposed_photo_canvas.width, filtered_precomposed_photo_canvas.height);

        if (SAVEDBG && useRemoveBg) {
          let filename = PcConfig.global.tmpDir + "5_filtered_precomposed_photo_canvas_" + variation.toString() + ".png";
          PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
            PcConfig.saveCanvasToFile(filtered_precomposed_photo_canvas, filename, "png");
        }
        */
        //overwrite whatever we had in the precomposed_photo_context
        precomposed_photo_context.drawImage(filtered_removebg_precomposed_photo_canvas, 0, 0, pose_width, pose_height);
        if (SAVEDBG && useRemoveBg) {
          let filename = PcConfig.global.tmpDir + "5_final_precomposed_photo_canvas_" + variation.toString() + ".png";
          PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
            PcConfig.saveCanvasToFile(precomposed_photo_canvas, filename, "png");
        }

      }

      full_composition_context.drawImage(precomposed_photo_canvas, pose_x, pose_y, pose_width, pose_height);
      if (SAVEDBG && useRemoveBg) {
        let filename = PcConfig.global.tmpDir + "6_full_composition_canvas_with_precomposition" + variation.toString() + ".png";
        PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
          PcConfig.saveCanvasToFile(full_composition_canvas, filename, "png");
      }

      // single_composed_frame_canvas = null;
    }

    // 4. overlay foreground image
    if (imgForeground)
    {
      full_composition_context.drawImage(imgForeground, 0, 0, template.size.width, template.size.height);
      if (SAVEDBG && useRemoveBg) {
        let filename = PcConfig.global.tmpDir + "7_full_composition_canvas_with_foreground" + variation.toString() + ".png";
        PcDbg.log(FRAMEDBG|CRASHDBG, "saving filtered canvas to filename", filename);
          PcConfig.saveCanvasToFile(full_composition_canvas, filename, "png");
      }

    }

    return full_composition_canvas;
  }
  
  static createPhotoData(format, skin, filter_dict, sessionShots, useRemoveBg=false) //used by saveAll, this is logical
  {
    var frames = [];
    var n = 0;
    if (format.animation=="boomerang" &&  sessionShots[0].frames.length>=4) n = 3;
    for (let i=0; i<sessionShots.length; i++) {
      frames[i] = sessionShots[i].frames[n];
    }
    var canvas = PcTemplates.createComposedFrames(format, skin.color, skin.background, skin.foreground, frames, filter_dict, useRemoveBg);
    var data = PcConfig.canvasToData(canvas); // -> jpeg data ready
    return data;
  }

  static createGif4Data(format, skin, filter_dict, sessionShots, onFinished, useRemoveBg=false)
  {
    var frames = [];
    var canvas = []
    var gif = new GIF({workers: 2,quality: 20});

    for (let i=0; i<sessionShots.length; i++) {
      frames[i] = sessionShots[i].frames[0];
    }

    for (let i=0; i<sessionShots.length; i++)
    {
      canvas[i] = PcTemplates.createComposedFrames(format, skin.color, skin.background, skin.foreground, [frames[i]], filter_dict, useRemoveBg);
      gif.addFrame(canvas[i], {delay: 500});
    }

    gif.on('finished', (blob) => {
      var reader = new FileReader();
      reader.addEventListener("loadend", () => {
        onFinished(reader.result.replace(/^data:image\/\w+;base64,/, ""));
      });
      reader.readAsDataURL(blob);
    });

    gif.render();
  }

  static createBoomerangData(format, skin, filter_dict, sessionShots, onFinished, useRemoveBg)
  {
    var frames = [];
    var canvas = []
    var gif = new GIF({workers: 2,quality: 20});

    for (let i=0; i<sessionShots[0].frame.length; i++)
    {
      for (let j=0; j<sessionShots.length; j++) {
        frames[j] = sessionShots[j].frames[i];
      } 
      canvas[i] = PcTemplates.createComposedFrames(format, skin.color, skin.background, skin.foreground, frames, filter_dict, useRemoveBg);
      let canvasRedim = document.createElement('canvas');
      canvasRedim.width = canvas[i].width/2;
      canvasRedim.height = canvas[i].height/2;
      canvasRedim.getContext('2d').drawImage(canvas[i], 0, 0, canvasRedim.width, canvasRedim.height);
      gif.addFrame(canvasRedim, {delay: 100});
    }

    gif.on('finished', (blob) => {
      var reader = new FileReader();
      reader.addEventListener("loadend", () => {
        onFinished(reader.result.replace(/^data:image\/\w+;base64,/, ""));
      });
      reader.readAsDataURL(blob);
    });

    gif.render();
  }

  static getZoomCropCanvas(canvas, w, h, applyWideCapture = true)
  {
    let canvasWidth, canvasHeight, canvasX, canvasY;
    let destW, destH, destX, destY;

    if (applyWideCapture && PcConfig.scenario.mode=="photobooth" && !PcConfig.screen.format.wideCapture && PcConfig.scenario.cameraOrientation!="portrait")
    {
      canvasWidth = Math.min(canvas.width, canvas.height);
      canvasHeight = canvasWidth;
      canvasX = (canvas.width-canvasWidth)/2;
      canvasY = 0;
    }
    else {
      canvasWidth = canvas.width;
      canvasHeight = canvas.height;
      canvasX = 0;
      canvasY = 0;
    }

    let dRatio = w / h;
    let cRatio = canvasWidth / canvasHeight;

    if (dRatio<cRatio)
    {
      destH = canvasHeight;
      destW = canvasHeight*dRatio;
      destY = canvasY ;
      destX = canvasX + (canvasWidth-destW)/2;
    }
    else {
      destW = canvasWidth;
      destH = canvasWidth*(1/dRatio);
      destX = canvasX;
      destY = canvasY + (canvasHeight-destH)/2;
    }

    let resCanvas = document.createElement('canvas');
    resCanvas.width = w;
    resCanvas.height = h;
    let context = resCanvas.getContext('2d');

    context.imageSmoothingEnabled=true;
    context.imageSmoothingQuality="high";

    context.drawImage(canvas, destX, destY, destW, destH, 0, 0, w, h);

    return resCanvas;
  }

  static loadResource(imgUrl, fOnLoad=null)
  {
      if (imgUrl=="") return;
      var r = {url:imgUrl, image:new Image()}
      PcTemplates.resources.push(r);

      if (fOnLoad)
      {
        PcTemplates.resources[PcTemplates.resources.length-1].image.onload = ()=>{fOnLoad(imgUrl)};
        PcTemplates.resources[PcTemplates.resources.length-1].image.onerror = ()=>{fOnLoad(imgUrl)};
      }

      PcTemplates.resources[PcTemplates.resources.length-1].image.src = imgUrl + "?x=" + Math.random();
  }

  static getResource(imgUrl)
  {
    for (let i=0; i<PcTemplates.resources.length; i++)
    {
      if (PcTemplates.resources[i].url==imgUrl)
      {
        return PcTemplates.resources[i].image;
      }
    }
    return false;
  }

}
