class PcCaptureSessionShot
{
  constructor()
  {
    this.frames = [];
  }

  addFrame(data, dataIsCanvas=false)
  {
    this.frames.push(new PcCaptureSessionFrame(data, dataIsCanvas));
  }

  
  async removeBgShot(timeout)
  {
    let ret = (this.frames.length > 0);
    PcDbg.log(REMOVEDBG, "initially ret", ret);

    await Promise.all(
        this.frames.map(async (frame) =>
        {
          await frame.removeBgFrame(timeout);
          ret &= frame.isRemoveBgSuccess(); // if one is false, ret becomes false;
        }
      )
    );
       
    PcDbg.log(REMOVEDBG, "finally ret", ret);
    return ret;
  }
  filterShot(filter_dict, index) // a PcCaptureSessionShot can consist of multiple PcCaptureSessionFrames
  {
    /* // useless now
    this.frames.forEach(frame => { 

      frame.filterFrame(filter_dict, index);
      
      if (frame.isRemoveBgSuccess()) {
         frame.filterFrame(filter_dict, index, true); // also filter the removebged frame
      }
    
    });
    */
  }

  /* per Shot framing now takes predef_frames_landmarks.
  they are used to potentially avoid recomputing landmarks for specific frames (from one shot - which can be animated with multiple frames)
  */

  async framing(framing, predef_frames_landmarks, faceRatio, centerRatio, frameSize, alert) /* framing is a PcFraming instance from PcCaptureSession, yuk */
  {
    var frames_landmarks = [];

    for (let i=0; i<this.frames.length; i++) // for all frames in shot (animated )
    {
      // ensure cur_predef_frame_landmarks sanity
      let cur_predef_frame_landmarks;
      if (predef_frames_landmarks == null || predef_frames_landmarks.length < i+1) { /* fixme later: hack for predef_frames_landmarks sizing vs unpredictible frame.length! */
        cur_predef_frame_landmarks = null;
      } else {
        cur_predef_frame_landmarks = predef_frames_landmarks[i];
      }
      /* call the framing per frame 
      accumulate the frame landmarks
      */
      frames_landmarks.push(
        await this.frames[i].framing(framing, cur_predef_frame_landmarks , faceRatio, centerRatio, frameSize, alert)
      );
      PcDbg.log(FRAMINGDBG, "PCSS: framing -> frames_landmarks are now", JSON.stringify(frames_landmarks));

    }

    //return the frames_landmarks for this shot
    return frames_landmarks;
  }

  delete()
  {
    this.frames.forEach(frame => frame.delete());
    this.frames.splice(0);
    this.frames = null;
  }
}
