class PcCamera extends React.Component
{
  constructor(props)
  {
    super(props);

    this.container = React.createRef();
    this.canvas = React.createRef();
    this.animationInterval = null;
    this.oval = false;
  }

  setOpacity(x)
  {
    this.canvas.current.style.opacity=x;
  }

  startAnimation()
  {
    this.animationInterval = setInterval(()=>this.updateCanvas(), 60);
  }

  stopAnimation()
  {
    clearInterval(this.animationInterval);
  }

  doFlash()
  {
    setTimeout(()=>{this.buttonFlash.current.style.transition=""}, 1);
    setTimeout(()=>{this.buttonFlash.current.style.opacity=1}, 20);
    setTimeout(()=>{this.buttonFlash.current.style.transition="all 1s ease-out"}, 40);
    setTimeout(()=>{this.buttonFlash.current.style.opacity=0}, 60);
  }

  showOval()
  {
    this.oval = true;
  }

  hideOval()
  {
    this.oval= false;
  }

  updateCanvas()
  {
    if (this.canvas.current)
    {
      let canvas = PcCameraControl.getCurrentFrame(this.props.width, this.props.height);

      this.canvas.current.width = this.props.width;
      this.canvas.current.height = this.props.height;
      this.canvas.current.getContext('2d').drawImage(canvas, 0, 0, this.props.width+2, this.props.height+2);

      if (PcConfig.screen.capture.framingOval)
      {
        let context = this.canvas.current.getContext('2d');

        if (this.props.width>=this.props.height)
        {
          context.ellipse(this.props.width*0.5, this.props.height*0.43, this.props.height*0.41/2, this.props.height*0.41*1.34/2, 0, 0, Math.PI*2);
        }
        else
        {
          context.ellipse(this.props.width*0.5, this.props.height*0.43, this.props.width*0.5/2, this.props.width*0.5*1.34/2, 0, 0, Math.PI*2);
        }

        //context.strokeStyle = 'rgba(255, 255, 255, 0.8)';
        context.strokeStyle = PcConfig.screen.start.startButton.backgroundColor;
        context.setLineDash([25, 10]);
        context.lineWidth = 6*PcConfig.renderSize;
        context.stroke();
      }

      canvas = null;
    }

    if (this.props.kind=="photo") this.doFlash();
  }

  render()
  {
    if (this.props.active)
    {
      this.startAnimation();
    }else {
      this.stopAnimation();
    }

    if (this.props.oval) {this.showOval()}

    return e('div',
        {
          className:"pccameracontainer",
          ref:this.container,
          style:
          {
            position:"absolute",
            opacity:this.props.animation!="" ? 0 : 1,
            animation:this.props.animation,
            animationDelay:this.props.showDelay,
            left: this.props.x,
            top:this.props.y,
            width:this.props.width,
            height:this.props.height,
            backgroundColor:"#000000",
          }
        },
        e('canvas',
          {
            ref:this.canvas,
            style:
            {
              position:"absolute",
              left:0,
              top:0,
              width:this.props.width,
              height:this.props.height,
              zIndex:10,
              //transform: PcConfig.scenario.cameraOrientation=="portrait" ? "scaleX(-1) rotate(-90deg)" : "scaleX(-1)",
              transform: "scaleX(-1)",
              transition: "all 0.5s ease-out",
            }
          }
        ),
        e(PcMedia,
          {
            position:"absolute",
            y:0,
            x:0,
            width:this.props.width,
            height:this.props.height,
            zIndex:100,
            content:this.props.foreground
          }
        )
      );
  }
}
