class PcVideoPlayer extends React.Component
{
  constructor(props)
  {
    super(props);
    this.video = React.createRef();
    this.displayButton = React.createRef();
    this.playing=true;
  }

  componentDidUpdate()
  {
    if (this.video.current)
    {
        if (this.props.file!=undefined && this.props.file!="" && this.props.display!="none")
        {
          this.video.current.volume = PcConfig.scenario.videoVolume;
          this.video.current.pause();
          this.video.current.load();
          this.video.current.play();
          this.displayButton.current.style.display = "none";
        }
    }
  }

  reload()
  {

  }

  onVideoError()
  {

  }

  onVideoEnd()
  {
    this.displayButton.current.style.display = "block";
    this.playing = false;
  }

  onClickVideo()
  {
    this.video.current.pause();
    this.playing = false;
    this.displayButton.current.style.display = "block";
  }

  onClickBtVideo()
  {
    this.video.current.play();
    this.playing = true;
    this.displayButton.current.style.display = "none";
  }

  render()
  {
    if (this.props.display=="none")
    {
        if (this.video.current)
        {
          this.onClickVideo()
        }
    }

    return e("div",
      {
        className:"pcvideoplayer",
        style:
        {
          opacity:0,
          animation:PcConfig.scenario.elementsAnimationStyle,
          animationDelay:this.props.showDelay,
        }
      },
      e("video",
      {
        autoPlay:"autoplay",
        loop:0,
        onError: ()=>this.onVideoError(),
        onEnded: ()=>this.onVideoEnd(),
        onClick:()=>this.onClickVideo(),
        ref:this.video,
        style:
        {
          position:"absolute",
          left:this.props.x,
          top:this.props.y,
          width:this.props.width,
          height:this.props.height,
          boxShadow: 5*PcConfig.renderSize + "px " + 5*PcConfig.renderSize + "px " + 10*PcConfig.renderSize + "px rgba(0, 0, 0, .33)",
        }
      },
      e("source",
        {
          src:this.props.file,
          type:"video/mp4"
        }
      )
    ),
    e(PcMedia,
      {
        onClick:()=>this.onClickVideo(),
        position:"absolute",
        x:this.props.x,
        y:this.props.y,
        width:this.props.width,
        height:this.props.height,
        content:this.props.foreground
      }
    ),
    e("img",
      {
        onClick:()=>this.onClickBtVideo(),
        ref:this.displayButton,
        src:"ressources/btplay.png",
        style:
        {
          position:"absolute",
          left:this.props.x,
          top:this.props.y,
          width:this.props.width,
          height:this.props.height,
          display:"none",
        }
      }
    ));
  }

}
