class PcFormChoice extends PcFormElement
{
  constructor(props)
  {
    super(props);

    var choicesList = props.choices.split("|");

    this.choiceButton = [];
    for (let i=0; i<choicesList.length; i++) this.choiceButton[i] = React.createRef();

    this.okButton = React.createRef();

    this.state = {okButtonVisible:false}
  }

  setFocus()
  {
    //ReactDOM.findDOMNode(this.emailInput.current).focus();
  }

  onInputChange()
  {

  }

  reset()
  {
    for (let i=0; i<this.choiceButton.length; i++)
      this.choiceButton[i].current.unselect();

    this.setState({okButtonVisible:false})
  }

  onKeyPressed(key)
  {

  }

  onClickButton(index, item)
  {
    let nbSelected = 0;
    for (let i=0; i<this.choiceButton.length; i++)
        if (this.choiceButton[i].current.isSelected()) nbSelected++;

    if (this.props.max>0 && nbSelected>=this.props.max)
    {
      if (!this.choiceButton[index].current.isSelected()) return;
    }

    if (this.props.multipleChoices)
    {
      this.choiceButton[index].current.isSelected() ? this.choiceButton[index].current.unselect() : this.choiceButton[index].current.select();
    }
    else {
      for (let i=0; i<this.choiceButton.length; i++)
        (i==index) ? this.choiceButton[i].current.select() : this.choiceButton[i].current.unselect();
    }

    let res = []
    for (let i=0; i<this.choiceButton.length; i++)
        if (this.choiceButton[i].current.isSelected()) res.push(this.choiceButton[i].current.props.label);

    let answer = res.join(",");

    console.log(answer);
    this.props.answered(answer);
    this.validate()=="" ? this.setState({okButtonVisible:true}) : this.setState({okButtonVisible:false});
    this.forceUpdate();
  }

  onClickOkButton()
  {
    setTimeout(()=>this.props.okClick(), 10);
  }

  validate()
  {
    if (!this.props.required) return "";

    for (let i=0; i<this.choiceButton.length; i++)
      if (this.choiceButton[i].current.isSelected()) return "";

    return this.props.errorMessage != "" ? this.props.errorMessage : " ";
  }

  onClick(e)
  {
    if (e.type === 'touchend')
    {
      e.preventDefault();
      if (e.targetTouches.length>0) return;
    }

    if (this.props.sound) this.props.sound.play();
    if (this.props.onClick) this.props.onClick();
  }

  onClickLabelDoc()
  {
    if (this.props.onClickChoiceDoc) this.props.onClickChoiceDoc();
  }

  render()
  {
    var choicesList = this.props.choices.split("|");

    const choices = choicesList.map( (item, index)=>
      {
        var spacingHLeft = index==0 ? 0 : 5*PcConfig.renderSize;
        return e(PcFormChoiceButton,
          {
            key:index,
            ref:this.choiceButton[index],
            onClick:()=>this.onClickButton(index, item),
            active:this.props.active,
            label:item,
            sound:PcConfig.sounds.keyboard,
            position:"relative",
            fontSize:PcConfig.scenario.fontSize,
            color: PcConfig.scenario.fontColor,
            spacingHLeft:spacingHLeft,
            spacingHRight:5*PcConfig.renderSize,
            spacingV:5*PcConfig.renderSize,
            halign:"left",
            showDelay:"0,1s"
          }
        );
      }
    );

    let mentions;

    if (this.props.mentions!="")
    {
      mentions = e(PcLabel,
        {
          ref:this.mention,
          label:this.props.mention,
          onClickDoc:()=>this.onClickLabelDoc(),
          position:"relative",
          width:this.props.width,
          height:this.props.height,
          halign : this.props.centered ? "center" : "left",
          fontSize:PcConfig.scenario.fontSizeSmall,
          color: PcConfig.scenario.fontColor,
          showDelay:"0,1s"
        }
      );
    } else {
        mentions = null;
    }

    const okButton = PcConfig.getOkButton(this);
    
    return e('div',
      {
        className:"pcchoicecontainer",
        onClick:(e)=>{this.onClick(e)},
        onTouchEnd:(e)=>{this.onClick(e)},
        style:
        {
          textAlign:this.props.centered ? "center" : "left",
          transition:"all 0.25s ease-out",
        }
      },
        e(PcLabel,
          {
            label:this.props.label,
            onClickDoc:()=>this.onClickLabelDoc(),
            position:"relative",
            width:this.props.width,
            height:this.props.height,
            halign : this.props.centered ? "center" : "left",
            fontSize:PcConfig.scenario.fontSize,
            color: PcConfig.scenario.fontColor,
            showDelay:"0,1s"
          }
        ),
        e('div', {style:{width:"100%", height:10*PcConfig.renderSize}}),
        e("div",
          {
            className:"pcchoices",
            style:
            {
              position:"relative",
              display:"inline-flex",
              justifyContent: this.props.centered ? "center" : "flex-start",
              flexWrap: "wrap",
              alignContent:"left",
              justifyContent:"center",
              animation:PcConfig.scenario.elementsAnimationStyle,
              animationDelay:this.props.showDelay,
            }
          },
          choices
        ),
        e('div', {style:{width:"100%", height:1*PcConfig.renderSize}}),
        mentions,
        e("div",
          {
            className:"pcok",
            style:
            {
              position:"relative",
              display:"inline-flex",
              justifyContent: this.props.centered ? "center" : "flex-start",
              flexWrap: "wrap",
              alignContent:"left",
              justifyContent:"left",
              animation:PcConfig.scenario.elementsAnimationStyle,
              animationDelay:this.props.showDelay,
            }
          },
          okButton
        ),
        e('div', {style:{width:"100%", height:100*PcConfig.renderSize}}),
      );

  }

}
