
ONE_MINUTE_IN_SECONDS = 60
ONE_HOUR_IN_SECONDS = ONE_MINUTE_IN_SECONDS * 60
ONE_DAY_IN_SECONDS = ONE_HOUR_IN_SECONDS * 24
ONE_MONTH_IN_SECONDS = 30 * ONE_DAY_IN_SECONDS

from time import perf_counter
import sys
import platform
import subprocess

def fdbg(fn, doit, *args):
    if not doit:
        return
    fh = open(fn, 'a')
    s = _dbg(*args)
    fh.write(s)
    dbg(doit, *args)

def dbg(doit, *args):
    if not doit:
        return
    s = _dbg(*args)
    sys.stderr.write((s))

def _dbg(*args): 
    import inspect
    import logging
    logger = logging.getLogger('root')
    logger.setLevel(logging.DEBUG)
    string=' '.join(map(str,args))
    # Get the previous frame in the stack, otherwise it would
    # be THIS function!
    func = inspect.currentframe().f_back.f_back.f_code
    # Dump the message + the name of this function to the log.
    my_str = "%-48s %-20s\n" % (func.co_name + "():" + str(func.co_firstlineno) + ": ", string)
    return my_str


def get_time():
    return perf_counter()


def is_windows():
	is_w = False
	p = platform.system().lower()
	print(p)
	if p == "windows" or p.startswith("cygwin"):
		is_w = True
	return is_w

def my_ping(sHost) -> bool:
    try:
        subprocess.check_output("ping -{} 1 {}".format(("c","n")[is_windows()], sHost), shell=True)
        r = True
    except Exception as ex:
        dbg(True, f"exception, {ex}")
        r = False
    # dbg(True, f"returns {r}")	
    return r