<?php
include_once 'config.php' ;

set_time_limit(0);

function purgeMediaFiles($dir)
{
  $files = glob("../$dir/*");
  $now   = time();

  foreach ($files as $file)
  {
    if (is_file($file))
    {
      if ($now - filemtime($file) >= 60 * 60 * 24 * 30)  // 30 days
      {
        unlink($file);
      }
    }
  }
}

purgeMediaFiles("photos");
purgeMediaFiles("videos");


// Clear old content
$sql     = 'SELECT * FROM phocabine_photos WHERE sync = 1 AND date < DATE_SUB(NOW(), INTERVAL 1 MONTH) ORDER BY id_photo' ;
$lines     = $db->selectAll($sql) ;
foreach($lines as $line)
{
    $db->update('phocabine_photos', array('sync' => 3), 'id_photo = ' . $line-> id_photo) ;

    if ($line->file)
    {
        unlink(getPhotoFile($line->file)) ;
    }

    if ($line->video)
    {
        unlink(getVideoFile($line->video)) ;
    }
}

$oConfigXml = simplexml_load_file(getXmlFile('config.xml')) ;
if($oConfigXml->photo->golden_mode == 1)
{
    //manual lots won
    $sql     = 'SELECT * FROM photocabine_lots WHERE config = "' . $oConfigXml->id . '" AND won IS NOT NULL AND auto IS NULL' ;
    $lines     = $db->selectAll($sql) ;

    $aDates = array() ;
    foreach($lines as $line)
    {
        array_push($aDates, $line->date . '/' . $line->id) ;
    }
    $params['dates'] = implode('|', $aDates) ;

    $ch = curl_init();
    $opts =  array(
        CURLOPT_CONNECTTIMEOUT => 10,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_TIMEOUT        => 600
      );
    $opts[CURLOPT_POSTFIELDS] = $params;
    $opts[CURLOPT_URL] = SITE . '/scripts/upload_lots_date.php?config=' . $oConfigXml->id ;

    curl_setopt_array($ch, $opts);

    //transmit manual lots won
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false);
    $result = curl_exec($ch);

    //echo $result ;

    if ($result)
    {
        if ($result != '1')
        {
            $a = explode('|', $result) ;

            //delete local entries not returned by server
            $sql     = 'SELECT * FROM photocabine_lots WHERE config = "' . $oConfigXml->id . '" AND won IS NULL AND auto IS NULL' ;
            $lines     = $db->selectAll($sql) ;

            foreach($lines as $line)
            {
                $exist = false;

                foreach($a as $date_info)
                {
                    $a2 = explode('/', $date_info);
                    $date = $a2[0];
                    if ($date==$line->date)
                    {
                        $exist = true;
                        break;
                    }
                }

                if (!$exist)
                {
                    $sql = 'DELETE FROM photocabine_lots WHERE id_lot=' . $line->id_lot ;
                    $db->query($sql);
                }
            }

            //create new manual lots gets from online script, if they don't exist
            foreach($a as $date_info)
            {
                $a2 = explode('/', $date_info) ;

                $date = $a2[0] ;

                if ($date!="" && $date!=0 && $date!="0000-00-00 00:00:00")
                {

                    $sql     = 'SELECT * FROM photocabine_lots WHERE config = "' . $oConfigXml->id . '" AND won IS NULL AND auto IS NULL AND date="'.$date.'"' ;
                    $lines     = $db->selectAll($sql) ;

                    if (!$lines || count($lines)==0)
                    {
                        $data = array() ;
                        $data['date']     = $date ;
                        $data['gain']     = $a2[1] ;
                        $data['config']    = $oConfigXml->id ;
                        $db->insert('photocabine_lots', $data) ;
                    }
                }
            }
        }
        else
        {
            $sql = 'DELETE FROM photocabine_lots WHERE config = "' . $oConfigXml->id . '" AND won IS NULL AND auto IS NULL';
            $db->query($sql);
        }
    }
}


// Sync content online
$sql     = 'SELECT * FROM phocabine_photos WHERE sync IS NULL ORDER BY id_photo' ;
$line     = $db->select($sql) ;
if($line)
{
    $db->update('phocabine_photos', array('sync' => 1), 'id_photo = ' . $line->id_photo) ;

    //echo 'Sync =>' . $line->file . '<br/>' ;
    $ch = curl_init();
    $params = get_object_vars($line) ;

    $params['photo'] = '@' . getPhotoFile($line->file) ;

    if ($line->video && getVideoFile($line->video))
    {
        $params['videoo'] = '@' . getVideoFile($line->video) ;
    }

    if ($line->file_gif && getPhotoFile($line->file_gif))
    {
        if (file_exists(getPhotoFile($line->file_gif)))
        {
            $params['gif'] = '@' . getPhotoFile($line->file_gif) ;
        }else {
            unset($params['file_gif']) ;
        }
    }

    $opts =  array(
        CURLOPT_CONNECTTIMEOUT => 10,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_TIMEOUT        => 600
      );
    $opts[CURLOPT_POSTFIELDS] = $params;
    $opts[CURLOPT_URL] = SITE . '/scripts/upload_photo.php' ;

    curl_setopt_array($ch, $opts);
    curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false);
    $result = curl_exec($ch);

    var_dump($result) ;

    if ($result == '1')
    {
      echo "ok sync";
    }else {
        $db->query('UPDATE phocabine_photos SET sync = NULL WHERE id_photo = ' . $line->id_photo) ;
        echo "ko sync";
    }

    exit ;
}

// Convert FLV to MP4
$sql     = 'SELECT * FROM phocabine_photos WHERE sync = 0 AND video IS NOT NULL ORDER BY id_photo' ;
$line     = $db->select($sql) ;
if($line)
{
    $file = substr($line->video, 0, strpos($line->video, '.')) ;

    $input_video = getVideoFile($file . '.mov');
    $input_silence =  getVideoFile("temp/audio.mp3");

    $hd_video = getVideoFile($file."_hd.mp4");
    $resized_video = getVideoFile("temp/".$file."_video_resized.mp4");

    $overlayed_video =  getVideoFile("temp/".$file."_video_overlayed.mp4");
    $overlayed_video_forconcatfile = "temp/".$file."_video_overlayed.mp4";

    $question_video =  getVideoFile("temp/".$file."_video_question.mp4");
    $question_video_forconcatfile = "temp/".$file."_video_question.mp4";

    $final_video_temp = getVideoFile("temp/".$file.".mp4");
    $final_video = getVideoFile($file . '.mp4');

    $concat_file = getVideoFile($file."_concat.txt");

    $contrast = "1.2"; // -2 to 2 (default 1 : no change)
    $brightness = "0.1"; // -1 to 1 (default 0 : no change)
    $saturation = "1.2"; // 0 to 3 (default 1 : no change)

    $nosound = ($oConfigXml->vstep1->nosound==1) ? "-an" : "";

    //$codec = "-r 25 -b:a 128k -b:v 4000k -g 12 -bf 2 $nosound";
    $codec = "-r 25 -b:a 128k -b:v 4000k -g 12 -bf 2 $nosound -pix_fmt yuv420p";

    $finalvideosize = "1920x1080";
    $fvw = 1920;
    $fvh = 1080;

    $question = $line->video_question ? $line->video_question : 2 ;

    $img = 'title' . $question . '_img2' . $line->lang ;
    $image_file = $oConfigXml->vstep1->front ;
    $image = getRessourceFile($image_file) ;

    //resize original video and apply contrast/brightness/saturation effect
    //$cmd = FFMPEG . " -i $input_video -af highpass=f=150,lowpass=f=8000 -vf eq=$contrast:$brightness:$saturation -s $finalvideosize $codec -y $resized_video";
    //$cmd = FFMPEG . " -i $input_video -s $finalvideosize $codec -y $resized_video";
    //exec($cmd);

    //create overlayed video
    if ($image_file != '' && file_exists($image))
    {
        $cmd = FFMPEG . " -i $input_video -i $image -filter_complex overlay -s $finalvideosize $codec -y $overlayed_video";
        exec($cmd);
    }
    else
    {
        $cmd = FFMPEG . " -i $input_video -s $finalvideosize $codec -y $overlayed_video";
        exec($cmd);
    }

    // Add Image Question
    $img = 'title' . $question . '_img' . $line->lang ;
    $image_file = $oConfigXml->vstep1->$img ;
    $image = getRessourceFile($image_file) ;

    if ($image_file != '' && file_exists($image))
    {
        $input_question = getVideoFile("temp/".$file."_question.jpg");
        copy($image, $input_question);

        //create question video
        $cmd = FFMPEG . " -loop 1 -i $input_question -i $input_silence -pix_fmt yuv420p -s $finalvideosize $codec -t 4 -y $question_video";
        exec($cmd);

        //concat question video and overlayed video
        $f = fopen($concat_file, "w");
        fwrite($f, "file $question_video_forconcatfile\r\n");
        fwrite($f, "file $overlayed_video_forconcatfile");
        fclose($f);

        $cmd = FFMPEG . " -f concat -i $concat_file -s $finalvideosize $codec -y $final_video" ;
        exec($cmd);

        unlink($input_question);
        unlink($concat_file);

    $thumbtime = 6;
    }
    else
    {
           $thumbtime = 0;
        copy($overlayed_video, $final_video);
    }

    //extract first frame as jpeg
    $thumb = getPhotoFile($line->file);
    $cmd = FFMPEG . " -ss $thumbtime -i $final_video -vframes 1 -s 1280x720 -f image2 -y $thumb";
    exec($cmd);

    if(file_exists($resized_video)) unlink($resized_video);
    if(file_exists($overlayed_video)) unlink($overlayed_video);
    if(file_exists($question_video)) unlink($question_video);
    if(file_exists($final_video_temp)) unlink($final_video_temp);

    if (file_exists($final_video))
    {
        unlink($input_video);
        $db->update('phocabine_photos', array('video' => $file . '.mp4'), 'id_photo = ' . $line->id_photo) ;
    }

    $db->query('UPDATE phocabine_photos SET sync = NULL WHERE id_photo = ' . $line->id_photo) ;

    echo 1 ;

    exit ;
}

// Retrieve Selfie from Internet
if($oConfigXml->params->mode == 3)
{
    $config = $oConfigXml->id ;

    $selfies = @simplexml_load_file(SITE . 'scripts/get_selfies.php?config=' . $config . '&device=' . DEVICE_ID) ;

    if ($selfies && count($selfies->selfie))
    {
        foreach($selfies->selfie as $selfie)
        {
            $context = stream_context_create(array('http' => array('timeout' => 60)));
            $raw = @file_get_contents($selfie->photo, false, $context) ;

            if ($raw)
            {
                $id     = uniqid($config . '_');
                $name     = getPhotoFile($id . '.jpg') ;
                file_put_contents($name, $raw) ;

                $data = array() ;
                $data['config']     = $config ;
                $data['device']     = DEVICE_ID ;
                $data['lang']         = 1 ;
                $data['email']         = $selfie->email ;
                $data['file']         = $id . '.jpg' ;
                $data['notif']         = -1 ;
                $data['notif2']        = -1 ;
                $data['notif3']        = -1 ;
                $data['form']         = $selfie->form ;
                $data['format']         = $selfie->format ;
                $data['date']         = date('Y-m-d H:i:s') ;
                $data['sync']         = 0 ;

                $id_photo = $db->insert('phocabine_photos', $data) ;

                file_get_contents(SITE . 'scripts/get_selfies.php?id_selfie=' . $selfie->id_selfie) ;
            }
        }

        echo 1 ;

        exit ;
    }
}

?>
